Proxmox/setup/mariadb_setup.sh

82 lines
2.4 KiB
Bash
Raw Normal View History

2022-01-19 00:34:53 +01:00
#!/usr/bin/env bash
# Setup script environment
set -o errexit #Exit immediately if a pipeline returns a non-zero status
set -o errtrace #Trap ERR from shell functions, command substitutions, and commands from subshell
set -o nounset #Treat unset variables as an error
set -o pipefail #Pipe will exit with last non-zero status if applicable
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
2022-02-02 03:50:56 +01:00
CROSS='\033[1;31m\xE2\x9D\x8C\033[0m'
CHECKMARK='\033[0;32m\xE2\x9C\x94\033[0m'
RETRY_NUM=5
RETRY_EVERY=3
NUM=$RETRY_NUM
2022-01-19 00:34:53 +01:00
trap die ERR
trap 'die "Script interrupted."' INT
function error_exit() {
trap - ERR
local DEFAULT='Unknown failure occured.'
local REASON="\e[97m${1:-$DEFAULT}\e[39m"
local FLAG="\e[91m[ERROR:LXC] \e[93m$EXIT@$LINE"
msg "$FLAG $REASON"
exit $EXIT
}
function msg() {
local TEXT="$1"
echo -e "$TEXT"
}
# Prepare container OS
msg "Setting up container OS..."
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null
2022-02-02 03:50:56 +01:00
while [ "$(hostname -I)" = "" ]; do
1>&2 echo -e "${CROSS} \e[1;31m No Network: \e[0m $(date)"
sleep $RETRY_EVERY
((NUM--))
if [ $NUM -eq 0 ]
then
1>&2 echo -e "${CROSS} \e[1;31m No Network After $RETRY_NUM Tries \e[0m"
exit 1
fi
done
echo -e "${CHECKMARK} \e[1;92m Network Connected: \e[0m $(hostname -I)"
2022-01-19 00:34:53 +01:00
# Update container OS
msg "Updating container OS..."
2022-02-03 09:24:45 +01:00
apt-get update &>/dev/null
2022-01-19 00:34:53 +01:00
apt-get -qqy upgrade &>/dev/null
# Install prerequisites
msg "Installing Prerequisites..."
2022-01-30 11:12:10 +01:00
apt-get update &>/dev/null
2022-01-19 00:34:53 +01:00
apt-get -qqy install \
curl \
sudo &>/dev/null
# Installing MariaDB
msg "Installing MariaDB..."
2022-01-21 21:45:06 +01:00
curl -LsS https://r.mariadb.com/downloads/mariadb_repo_setup | sudo bash &>/dev/null
2022-01-21 21:53:43 +01:00
apt-get update >/dev/null
apt-get install -y mariadb-server &>/dev/null
2022-01-19 00:34:53 +01:00
# Customize container
msg "Customizing container..."
rm /etc/motd # Remove message of the day after login
rm /etc/update-motd.d/10-uname # Remove kernel information after login
touch ~/.hushlogin # Remove 'Last login: ' and mail notification after login
GETTY_OVERRIDE="/etc/systemd/system/container-getty@1.service.d/override.conf"
mkdir -p $(dirname $GETTY_OVERRIDE)
cat << EOF > $GETTY_OVERRIDE
[Service]
ExecStart=
ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,38400,9600 \$TERM
EOF
systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
# Cleanup container
msg "Cleanup..."
rm -rf /mariadb_setup.sh /var/{cache,log}/* /var/lib/apt/lists/*